#include <iostream>
using namespace std;
class Poly
{
public:
	Poly();
	Poly(int,double []);
	Poly(const Poly&);
	Poly& operator=( const Poly& );
	~Poly();
	Poly& operator+=(const Poly&);
	Poly& operator-=(const Poly&);
	Poly& operator*=(const Poly&);
	Poly& operator+( const Poly& ) ;
	Poly& operator-( const Poly& ) ;
	Poly& operator*( const Poly& ) ;
	Poly& operator/( const Poly& ) ;
	void print() const;
private:
	double * nCoef;
	int nDegree;
};
Poly gp;  // Global variable for remaining polinoms untouched (globalna promenliva za da ne se promenqt polinomite)
Poly::Poly()
{
	nCoef = new double[1];
	nCoef[0] = 1;
	nDegree = 1;
}
Poly::Poly(int a,double b[])
{
	nDegree = a;
	nCoef = new double[nDegree];
	for ( int i=0 ; i< nDegree ; i++ ) 
	nCoef[i] = b[i];
	
}
Poly::Poly(const Poly& p)
{
	nDegree = p.nDegree;
	nCoef = new double[nDegree];
	for(int i = 0; i < nDegree; i++)
		nCoef[i] = p.nCoef[i];
}

Poly::~Poly()
{
	delete [nDegree] nCoef;
	nCoef = NULL;
}
Poly& Poly::operator=(const Poly& p) 
{
	if(this != &p) {
		delete [nDegree] nCoef;
		nDegree = p.nDegree;
		nCoef = new double[nDegree+1];
		for (int i=0 ; i< nDegree ; i++)
			nCoef[i] = p.nCoef[i];
	}
	return *this;
}
Poly& Poly::operator+=(const Poly& p) 
{
	if((nDegree>p.nDegree)||(nDegree==p.nDegree))
	{
		for (int i=0 ; i<p.nDegree ; i++)
			nCoef[i] += p.nCoef[i]; 
	}
	else {
		for (int i=0 ; i<nDegree ; i++)
			p.nCoef[i] += nCoef[i];
		*this = p ; 
	}
	return *this;
}
Poly& Poly::operator-=(const Poly& p) 
{
	if((nDegree>p.nDegree)||(nDegree==p.nDegree))
	{
		for (int i=0 ; i<p.nDegree ; i++)
			nCoef[i] -= p.nCoef[i]; 
	}
	else {
		for (int i=0 ; i<nDegree ; i++)
			p.nCoef[i] -= nCoef[i];
		*this = p ; 
	}
	return *this;
}
Poly& Poly::operator*=(const Poly& p)
{
	Poly tmp = *this;
	delete [nDegree] nCoef;
	nDegree += p.nDegree;
	nCoef = new double[nDegree];
	for(int e = 0; e < nDegree; e++)
			nCoef[e] = 0;
	for(int i = 0; i < tmp.nDegree; i++)
		for(int j = 0; j < p.nDegree; j++)
			nCoef[i+j] += tmp.nCoef[i] * p.nCoef[j];
	return *this;
}

Poly& Poly::operator+(const Poly& p)
{	
	gp = *this;  //za da se zapazi polinoma (this)  izpolzvame globalna promenliva "gp"
	gp += p;
	return gp;
}
Poly& Poly::operator-(const Poly& p)
{
	gp = *this;
	gp -= p;
	return gp;
}
Poly& Poly::operator*(const Poly& p)
{
	gp = *this;
	gp *= p;
	return gp;
}
void Poly::print() const
{
	if(nCoef[nDegree-1]!=0) cout<< nCoef[nDegree-1] << "x^" << nDegree-1 <<" ";
	for(int i = nDegree - 2; (i==0)||(i > 0); i--)
		if(nCoef[i]>0) cout << "+ " << nCoef[i] << "x^" << i <<" ";
		else if (nCoef[i]<0) cout  << nCoef[i] << "x^" << i <<" ";
	cout << endl;
}
void main() 
{
	double d[3]={1,2,1},d2[2]={2,1};
	Poly p(3,d);
	Poly p2(2,d2);
	Poly p3= p*p2;
	Poly p4= p+p2;
	Poly p5= p-p2;
	p5.print();
	p4.print();
	p3.print();
	p2.print();
	p.print(); 
}
